let productInfo = {
    productCode:"L1APP"
};
// 记录已被占用的key，防止使用冲突
let storageKeySet = new Set([
    "token",
    "cacheAccount", //缓存账号信息(包含中转码、IP、端口、用户账号名称)
    "serverConnectParams",// 服务器连接参数：ip、port、cusid
    "userHistory",
    "userHistoryAccount", // 账套用户密码
    "user",// Login接口返回的对象
    "userInfo",// GetQ5UserInfo接口返回的对象
    "loginRememberUser",// 记住用户名，记录上次登陆的用户名
    "lastLoginAccount",//上次登陆选择的账套
    "cacheDir",// 文件缓存路径根目录
    "userQueryHabit",// 用户筛选习惯
    "userEditHabit",//用户编辑习惯
    "L1APP_sptcheck", //采购送检单打印习惯
    "fileDataCache",
    "collectList",//收藏报表
    "downloadFileMap",//下载缓存文件的映射：MD5-最终保存的文件名（含后缀）
    "ordermlQuery",//车间指令单用户筛选习惯
    "reportHabit",// 报表筛选习惯
    "reportAction",//是否操作报表
    "blueprint",//蓝牙打印机对象    
    "activeTab",//国内外]
    "storageInfo",// GetQ5UserInfo接口返回的对象
    "outwareSaleMulti",//PDA_销售发货的草稿模式
    "outwareSaleMultiTh",//PDA_销售退货的草稿模式
    "inwareCPMulti",//PDA_生产进仓-选单扫描的草稿模式
    "inwareScan",//PDA_生产进仓-扫描开单的草稿模式
    "inwareBuyScanIN",//PDA_采购收货-扫描开单的草稿模式
    "inwareBuySglBill",//PDA_采购收货-选单扫描的草稿模式
    "inwareBuyScanOUT",//PDA_采购退货-扫描开单的草稿模式
    "inWareOtherScan",//PDA_其他进仓-扫描开单的草稿模式
    "inWareOtherBill",//PDA_其他进仓-选单扫描的草稿模式
    "outWareStorage",//PDA_仓库调拨-扫描开单的草稿模式
    "outWareOther",//PDA_其他出仓-扫描开单的草稿模式
    "outWareOtherBill",//PDA_其他出仓-选单扫描的草稿模式
    "wareCheck",//PDA_仓库盘点的草稿模式
    "inwareMoveMulti",//PDA_调拨进仓的草稿模式
    "outwareMoveMulti",//PDA_调拨出仓的草稿模式
    "inwareBuySglBill",//PDA_采购进仓-扫描开单的草稿模式
	"bigBarFrmDraft",//PDA_条码打包的草稿模式
    "inwareWXScanIn",//PDA_外协收货的草稿模式
	"outWareStorageLocal",//PDA_仓位调拨的草稿模式
    "inwareCPTwoScanDraft",//PDA_扫描生产进仓的草稿模式
    "mtrlWareTransDraft",//PDA_客户调货的草稿模式
    "warePdDraft",//PDA_产品盘点单的草稿模式
    "wareCheckLocationDraft",//PDA_仓位盘点的草稿模式
	"barcodePacketDraft",//PDA_板件分包扫描的草稿模式
    "taskFromDraft",//PDA_派工完工扫描的草稿模式
    "barcodeFinishDraft",//PDA_工序完工扫描的草稿模式
    "lastOrderBarcodeDraft",//PDA_最后工段完工扫描的草稿模式
    "taskBegFromDraft",//PDA_工序派工确认扫描的草稿模式
    "wkpOrderBarcodeDraft",//PDA_工段交接的草稿模式
    "outwareSaleNoScan",//PDA_下载发货单已扫条码的草稿模式
    "outwareScllBillDraft",//PDA_生产领料单的草稿模式
    "outwareScllFrmDraft",//PDA_生产领料单-扫描开单的草稿模式
    "outWareScllBackDraft",//PDA_生产退料单的草稿模式
    "barcodeChangeDraft",//PDA_条码调整单的草稿模式
    "barcodeModifyDraft",//PDA_条码变更单的草稿模式
    "outwareGPRDraft",//PDA_GPR出仓的草稿模式
    "quickEnterState",//组件：快捷录入记录纵向与横向习惯
    "sptcheckNewDraft",//新建采购送检单数据暂存
    "sptcheckNewNoCheckDraft",//新建采购收货不质检数据暂存
    "outWareWfjgBillDraft",//PDA_外协集合单：发出、退回、返工
	"sctaskWfjgDraft",//外协派工单的草稿模式
	"barcodeInfoDraft",//条码查询的草稿模式
    "outwareSaleNoScanDraft",//下载发货单已扫条码的草稿模式
	"qualitycheckWorkgroupEditDraft",//工段质检单草稿模式
    "scllScanModel", //记录单据扫描点数模式
    "scllDataObj", //记录单据是否忽略显示某数据（如：质检不合格）
    "checkUpdateApp", //记录app版本检测【取消】的信息
    "userFilterTitle",// 配套userQueryHabit，记录用户筛选习惯的标题
    "outwareSaleSpinOff",// 销售发货单，是否开启条码拆分
    "outwareScllPlanBillDraft",// PDA_发料单的草稿模式
    "saletask-edit-product-draft",
    "scllScanSort",// 记录生产发料单排序方式
    "gridSortHabit",
    "scllMxQtyZero",//记录生产发料新建本次发料数是否为0
    "productInfoEditHabit",//记录销售订单新建填写数据历史记录
    "serverCurrentRequestWay", //当前连接状态
    "barcodeModifyDraft", //条码变更单的草稿模式
    "outwareScllBillSpinOff",  // 生产领料单，是否开启条码拆分
    "outwareMoveSpinOff",  // 仓库调拨单-调出，是否开启条码拆分
    "warecheckSpinOff",  // 仓库盘点单-调出，是否开启扫条码改基数
    "warepdSpinOff",  // 产品盘点单-调出，是否开启扫条码改基数
    "homeHideSensitiveData", // 首页隐藏敏感数据
    "deviceId", // 设备唯一码
    "cpCheckZZMxReasonHistory", // 自制质检单异常原因历史输入
    "cpCheckWWMxReasonHistory", // 委外质检单异常原因历史输入
    "cpCheckMxReasonHistory", // 采购质检单异常原因历史输入
	"buyTaskScanModel", // 采购待收货扫描模式是否开启
  	"warecheckModeOff", // 仓库盘点表扫描模式类型
  	"warePdModeOff", // 产品盘点单扫描模式类型
  	"taskFinishAssignEmpHistory", // 记录工序完工历史填写负责人
	"outSourcingBillDraft", // 委外派工单的草稿模式
  	"outSourcingBillSpinOff", //  委外派工单，是否开启条码拆分
    "outwareScllPlanFuzzyOn", // 生产发料单-新建(卓凯定制)物料编码模糊匹配
    "w_bigbar", // PDA-条码打包打印习惯记录
    "finishAutocalWorkTime", // 完工单自动计算机台工时
    "inwarecp_iforder", // 生产进仓单-明细选计划
    "cpCheckZZMxSuggestHistory", // 自制质检单处理建议历史输入
    "cpCheckWWMxSuggestHistory", // 委外质检单处理建议历史输入
    "cpCheckMxSuggestHistory", // 采购质检单处理建议历史输入
]);
// 记录已被占用的事件名，防止使用冲突
let eventNameSet = new Set([
    "token_overdue", // 会话失效
    "keyback",// api平台级别的返回键事件
    "login_byaccount", //切换使用账号登陆
    "login_success",// 登录页面登录成功
    "check_app", // App版本检测
    "grid_style_updated",// 列表字段样式编辑成功事件携带参数{stylename:对应列表组件的style-name属性}
    "cust_save_success",// 客户详细信息界面保存成功
    // "outwaresale_save_success",// 销售发货单界面保存成功
    "cust_select",//客户选择
    "spt_select",//供应商选择
    "mtrldef_select",//物料选择
    "mtrlware_select",//库存选择
    "saletask_select",//销售订单选择
    "musttake_select",//客户应收帐选择
    "buytask_check_item_select",//采购质检单-质检项目选择
    "buytask_select",//采购订单选择
    "spttask_select",//供应商收货单选择
    "buytask_submit_edit_mx",//采购质检单编辑
    "storage_select",//仓库选择
    "workgroup_select",//工段选择
    "outware_scllplan_select",//发料通知单选择
    "outware_scll_plan_refresh",//发料单刷新
    "cpcheck_refresh",//采购质检单刷新
    "cpcheck_special_refresh",//特采审核列表界面刷新
    "inware_buy_refresh",//采购收货列表界面刷新
    "inware_buy_sptcheck_refresh",//采购收货仓审列表界面刷新
    "noticeclicked",//推送消息监听事件
    "baditem_select",//工序完工-工段不良项目选择
    "appintent", //极光推送通知/消息点击时间
    "emp_select", //生产质检单员工选择
    "process_select", //生产质检单工序选择
    "empap_select", //员工选择、ap指考核单
    "award-punish-refresh",//考核单修改刷新
    "quality_refresh", //生产质检单刷新
    "feedback_refresh", //工段巡检单刷新
    "equipment_refresh", //设备报修刷新
    "timespace_refresh", //主页刷新
    "process_checkitem_select",//生产质检单严格选择
    "wrkgrp_select",//组选择
    "workgroup_select",//工作中心选择
    "baditem_select",//不良项目选择
    "location_select",//存放位置选择
    "loca_select",//库位选择
    "gonggao_edit",//新建公告
    "rp_date_select",//报表日期选择
    "saletask_outware_select",//销售发货单选择
    "claim-refresh",//报销费用刷新
    "user_select",//选择用户
    "fxcheckbill-refresh",//供应商现场质检单保存
    "printer_select",//打印机选择
    "currcncy_select",//通用选择
    "outwareScll_refresh",//其他领料单列表刷新
    "outware_scll_refresh",//生产领料单列表刷新
    "sctask_finish_success",//工序完工提交成功
    "InwareOther_refresh",//其他进仓单刷新
    "wkp_select",//车间选择
    "InwareCp_refresh",//生产进仓单刷新
    "orderml_select",//指令单选择
	"OutwareOther_refresh",//其他出仓单刷新
	"warePdBill_refresh",//产品盘点单刷新
	"OutwarePzCodeTran_refresh",//仓位调拨单刷新
	"sctaskWfjg_refresh",//外协派工单刷新
    "empinfo-edit",//人员列表编辑
    "single-storage", // 仓库组件：单选仓库
    "storage-loca", // 仓库组件：选择仓库，选择仓位
    "equipment_select", // 车间生产-设备选择
    "refresh_dailyBadge", // 功能页更新微标数值
    "saletask_edit_refresh", // 销售订单明细列表刷新
    "cart_refresh",
    "saletask_edit_add",
    "saletask_mx_refresh",
    "longjoeAPI_connectModeChanged", // 中转/直连切换的事件，由longjoeAPI模块发出
    "longjoeAPI_mobyM71Decoded", // 监听MobyData系列扫描头回调，由longjoeAPI模块发出
    "business_chance_select", // 商机管理选择
    "business_chance_refresh", // 商机管理刷新
    "customer_interview_refresh", // 走访记录刷新
    "inwaremx_nocheck_refresh", // 采购收货明细待质检列表刷新
    "inwaremxwx_nocheck_refresh", // 委外收货明细待质检列表刷新
    "saletask_outware_refresh", // 销售发货单列表刷新
    "checkpoint_select", // 考核节点选择
    "eventlist_refresh", // 事件单刷新
    "equipment_repair_info_refresh", // 设备维护刷新
    "responsible_entity_select", // 责任主体选择
    "sctask_qccode_select", // 工序派工质检单质检码选择
    "aMap_select", // 定点位置选择
    "finish_refresh", // 工序完工单刷新
    "accounts_select", // 账号选择
    "itemdef_select", // 收支项目选择
    "bill_cust_inout_refresh", // 客户收支单刷新
    "print_template_select", // 打印模板选择
    "sctask_notplan_refresh", // 代派工刷新
    "bednet_quote_refresh", // 床网报价刷新
    "bednet_quote_mx_refresh", // 床网报价刷新明细
    "mattress_quote_refresh", // 床垫报价刷新,
    "mattress_quote_mx_refresh", // 床垫报价刷新明细,
    "spring_select", // 弹簧选择
    "mtrldef-selection", // 物料选择
    "bednet-selection", // 物料选择
    "mattress_edit_bednet", // 床垫报价修改床网,
]);
export {productInfo,storageKeySet,eventNameSet}